// ChatDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Chat.h"
#include "ChatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/* prottipos das funes locais */
DWORD Servidor (LPVOID L);


/////////////////////////////////////////////////////////////////////////////
// CChatDlg dialog

CChatDlg::CChatDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChatDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChatDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CChatDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChatDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChatDlg, CDialog)
	//{{AFX_MSG_MAP(CChatDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BT_ENVIAR, OnBtEnviar)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChatDlg message handlers

BOOL CChatDlg::OnInitDialog()
{
	DWORD id;
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//////////////////////////////////////////////////
	//          Criar a thread servidora            //
	//////////////////////////////////////////////////
	if (CreateThread (NULL, 0, (LPTHREAD_START_ROUTINE) Servidor, GetDlgItem (IDC_LIST1), 0, &id) == NULL)
		AfxMessageBox ("Erro ao criar thread!");

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CChatDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CChatDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


/*
Esta  a thread responsvel por receber mensagens.
Portanto, ela dever:
  - criar o mailslot;
  - entrar em um loop no qual aguarda por mensagens
*/
DWORD Servidor (LPVOID L)
{
  CListBox * Lista;

  Lista = (CListBox *) L;

  DWORD dwBytesLidos;
  HANDLE hMailslot;
  struct 
  {
    CHAR szNome[50];
	CHAR szMensagem[80];
  } Alarme;

  /* Criar o mailslot com:
	- timeout infinito
	- tamanho mximo da mensagem igual ao tamanho de Alarme
	- deve ser capaz de fazer um broadcast para todos os usurios que estiverem "conectados" 
  Em caso de erro, sair do programa.
  */
  hMailslot = CreateMailslot ("\\\\.\\mailslot\\mailslot1", sizeof (Alarme), INFINITE, NULL);
  if (hMailslot == INVALID_HANDLE_VALUE)
  {
    printf ("Erro ao tentar criar mailslot: %d\n", GetLastError());
	ExitProcess (0);
  }

  /* Loop infinito:
    - ler mensagens do mailslot
	- inser-las na lista de mensagen (j est pronto)
  */
  for(;;)
  {
    /* ler mailslot */
	ReadFile (hMailslot, &Alarme, sizeof (Alarme), &dwBytesLidos, NULL);
    Lista->AddString (CString ("[") +  CString (Alarme.szNome)  + CString ("] ")+ CString (Alarme.szMensagem));
  }

  return 0;
}

void CChatDlg::OnBtEnviar() 
{
	CListBox * Lista;
	CEdit * edNome;
	CEdit * edMsg;
	CEdit * edDominio;
	DWORD dwBytesEscritos;
	HANDLE hMailslot;
	CHAR szNomeMailslot[500];
	CHAR szDominio[50];

	struct 
	{
		CHAR szNome[50];
		CHAR szMensagem[80];
	} Alarme;
	
	edNome = (CEdit *) GetDlgItem (IDC_NOME);
	edMsg = (CEdit * ) GetDlgItem (IDC_MSG);
	edDominio = (CEdit *) GetDlgItem (IDC_DOMINIO);
	edDominio->GetWindowText (szDominio, 50);

	Lista = (CListBox *) GetDlgItem (IDC_LIST1);

	/* abrir o mailslot. Em caso de erro, imprimir uma mensagem e sair */
	sprintf (szNomeMailslot, "\\\\%s\\mailslot\\mailslot1", szDominio);
	hMailslot = CreateFile  (szNomeMailslot, GENERIC_WRITE, 
		                       FILE_SHARE_READ, NULL, OPEN_EXISTING, 
													 FILE_ATTRIBUTE_NORMAL, NULL);

	if (hMailslot == INVALID_HANDLE_VALUE)
	{
		AfxMessageBox ("Erro ao abrir mailslot!");
		ExitProcess (0);
	}


	/* obtm nome */
	edNome->GetWindowText (Alarme.szNome, 50);
	edMsg->GetWindowText (Alarme.szMensagem, 80);
	
	WriteFile (hMailslot, &Alarme, sizeof (Alarme), &dwBytesEscritos, NULL);

	CloseHandle (hMailslot);
}
