// clienteDlg.cpp : implementation file
//

#include "stdafx.h"
#include "cliente.h"
#include "clienteDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


/* prottipos das funes locais */
void MensagemErro (char * szMsg);

/* definio de um registro */
typedef struct
{
	char szNome[30];
	char szEndereco[40];
	char szTelefone[10];
} REGISTRO;


/* definio de um comando para o servidor */
typedef struct
{
	int iComando;								/* comando a ser executado */
	BOOL bSucesso;							/* indica se o comando foi executado com sucesso */
	REGISTRO Registro;					/* contedo do comando */
	char szConsAlt[30];					/* nome a ser alterado ou consultado */
	char szNomeCliente[30];			/* nome do cliente que enviou o comando */
} COMANDO;

/* tipos de comandos possveis */
#define COMANDO_INCLUSAO  0
#define COMANDO_CONSULTA  1
#define COMANDO_ALTERACAO 2


CClienteDlg::CClienteDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClienteDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClienteDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClienteDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClienteDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClienteDlg, CDialog)
	//{{AFX_MSG_MAP(CClienteDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_INSERIR, OnInserir)
	ON_BN_CLICKED(IDC_CONSULTAR, OnConsultar)
	ON_BN_CLICKED(IDC_ALTERAR, OnAlterar)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClienteDlg message handlers

BOOL CClienteDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	edNome = (CEdit *) GetDlgItem (IDC_NOME);
	edEndereco = (CEdit *) GetDlgItem (IDC_ENDERECO);
	edTelefone = (CEdit *) GetDlgItem (IDC_TELEFONE);
	edConsAlt = (CEdit *) GetDlgItem (IDC_CONS_ALT);
	edCliente = (CEdit *) GetDlgItem (IDC_CLIENTE);
	edServidor = (CEdit *) GetDlgItem (IDC_SERVIDOR);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CClienteDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CClienteDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CClienteDlg::OnInserir() 
{
	COMANDO Comando;
	DWORD dwBytesEscritos, dwBytesLidos;
	HANDLE hPipe;
	CHAR szSrv[50];
	CHAR szNomePipe[500];

	/* montar o comando para ser enviado para o servidor */
	Comando.iComando = COMANDO_INCLUSAO;
	edCliente->GetWindowText (Comando.szNomeCliente, 30);
	edNome->GetWindowText (Comando.Registro.szNome, 30);
	edEndereco->GetWindowText (Comando.Registro.szEndereco, 40);
	edTelefone->GetWindowText (Comando.Registro.szTelefone, 10);
	edServidor->GetWindowText (szSrv, 50);

	/* conectar-se ao servidor (ou seja, obter um handle para o named-pipe) */
	sprintf (szNomePipe, "\\\\%s\\pipe\\PipeServidor", szSrv);
	hPipe = CreateFile (szNomePipe, GENERIC_READ | GENERIC_WRITE, 0, NULL, 
											OPEN_EXISTING, 0, NULL);

	if (hPipe == INVALID_HANDLE_VALUE) 
		MensagemErro ("No conseguiu se conectar ao servidor");
	else
	{
		/*
			- escrever a mensagem no pipe
			- se tiver conseguido escrever, aguardar pela resposta do servidor
			- utilizar a funo AfxMessageBox para informar se conseguiu ou no inserir o registro
			- se ocorrer algum erro em uma chamada, report-lo ao operador atravs de MensagemErro
			- fechar o handle para o pipe
		*/
		if (WriteFile (hPipe, &Comando, sizeof (COMANDO), &dwBytesEscritos, NULL))
		{
			// aguarda pela resposta
			if (ReadFile (hPipe, &Comando, sizeof (COMANDO), &dwBytesLidos, NULL))
			{
				if (Comando.bSucesso)
					AfxMessageBox ("Registro inserido com sucesso!");
				else
					AfxMessageBox ("Registro no pde ser inserido!");
			}
			else
				MensagemErro ("Erro ao ler do pipe");
		}
		else
			MensagemErro ("Erro ao escreve no pipe");

		// fecha o handle
		CloseHandle (hPipe);
	}
}


void CClienteDlg::OnConsultar() 
{
	BOOL bEncontrou = FALSE;
	COMANDO Comando;
	DWORD dwBytesEscritos, dwBytesLidos;
	HANDLE hPipe;
	CHAR szSrv[50];
	CHAR szNomePipe[500];


	/* montar o comando para ser enviado para o servidor */
	edCliente->GetWindowText (Comando.szNomeCliente, 30);
	Comando.iComando = COMANDO_CONSULTA;
	edConsAlt->GetWindowText (Comando.szConsAlt, 30);
	edServidor->GetWindowText (szSrv, 50);

	/* conectar-se ao servidor (ou seja, obter um handle para o named-pipe) */
	sprintf (szNomePipe, "\\\\%s\\pipe\\PipeServidor", szSrv);
	hPipe = CreateFile (szNomePipe, GENERIC_READ | GENERIC_WRITE, 0, NULL, 
											OPEN_EXISTING, 0, NULL);

	if (hPipe == INVALID_HANDLE_VALUE) 
		MensagemErro ("No conseguiu se conectar ao servidor");
	else
	{
		/*
			- escrever a mensagem no pipe
			- se tiver conseguido escrever, aguardar pela resposta do servidor
			- se tiver consultado com sucesso, fazer bEncontrou = TRUE
			- utilizar a funo AfxMessageBox para informar se conseguiu ou no inserir o registro
			- se ocorrer algum erro em uma chamada, report-lo ao operador atravs de MensagemErro
			- fechar o handle para o pipe
		*/
		if (WriteFile (hPipe, &Comando, sizeof (COMANDO), &dwBytesEscritos, NULL))
		{
			// aguarda pela resposta
			if (ReadFile (hPipe, &Comando, sizeof (COMANDO), &dwBytesLidos, NULL))
				bEncontrou = Comando.bSucesso;
			else
				MensagemErro ("Erro ao ler do pipe");
		}
		else
			MensagemErro ("Erro ao escreve no pipe");

		// fecha o handle
		CloseHandle (hPipe);
	}

	/* se tiver encontrado, atualiza os campos */
	if (bEncontrou)
	{
		edNome->SetWindowText (Comando.Registro.szNome);
		edEndereco->SetWindowText (Comando.Registro.szEndereco);
		edTelefone->SetWindowText (Comando.Registro.szTelefone);
	}
	else
		AfxMessageBox ("Registro no pde ser encontrado!");
	
}


void CClienteDlg::OnAlterar() 
{
	COMANDO Comando;
	DWORD dwBytesEscritos, dwBytesLidos;
	HANDLE hPipe;
	CHAR szSrv[50];
	CHAR szNomePipe[500];


	/* montar o comando para ser enviado para o servidor */
	Comando.iComando = COMANDO_ALTERACAO;
	edCliente->GetWindowText (Comando.szNomeCliente, 30);
	edConsAlt->GetWindowText (Comando.szConsAlt, 30);
	edNome->GetWindowText (Comando.Registro.szNome, 30);
	edEndereco->GetWindowText (Comando.Registro.szEndereco, 40);
	edTelefone->GetWindowText (Comando.Registro.szTelefone, 10);
	edServidor->GetWindowText (szSrv, 50);

	/* conectar-se ao servidor (ou seja, obter um handle para o named-pipe) */
	sprintf (szNomePipe, "\\\\%s\\pipe\\PipeServidor", szSrv);
	hPipe = CreateFile (szNomePipe, GENERIC_READ | GENERIC_WRITE, 0, NULL, 
											OPEN_EXISTING, 0, NULL);

	if (hPipe == INVALID_HANDLE_VALUE) 
		MensagemErro ("No conseguiu se conectar ao servidor");
	else
	{
		/*
			- escrever a mensagem no pipe
			- se tiver conseguido escrever, aguardar pela resposta do servidor
			- utilizar a funo AfxMessageBox para informar se conseguiu ou no inserir o registro
			- se ocorrer algum erro em uma chamada, report-lo ao operador atravs de MensagemErro
			- fechar o handle para o pipe
		*/
		if (WriteFile (hPipe, &Comando, sizeof (COMANDO), &dwBytesEscritos, NULL))
		{
			// aguarda pela resposta
			if (ReadFile (hPipe, &Comando, sizeof (COMANDO), &dwBytesLidos, NULL))
			{
				if (Comando.bSucesso)
					AfxMessageBox ("Registro alterado com sucesso!");
				else
					AfxMessageBox ("Registro no pde ser alterado!");
			}
			else
				MensagemErro ("Erro ao ler do pipe");
		}
		else
			MensagemErro ("Erro ao escreve no pipe");

		// fecha o handle
		CloseHandle (hPipe);
	}
		
}


void MensagemErro (char * szMsg)
{
	char szMsgErro[200];
	sprintf (szMsgErro, "%s: %d", szMsg, GetLastError());
	AfxMessageBox (szMsgErro);
}

