// PrioridadesDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Prioridades.h"
#include "PrioridadesDlg.h"
#include "math.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/* prottipos das funes internas */
UINT Thread (LPVOID Param);      
void MensagemErro (char * szMsg);
void ExibePrioridadeProcesso (DWORD dwPrioridade);

/* variveis globais */
HANDLE hThread1, hThread2;
CWinThread * pThread1, * pThread2;
CComboBox * cbClassePrioridade, *	cbPrioridade1, * cbPrioridade2, * cbPrioridadePrimaria;


/////////////////////////////////////////////////////////////////////////////
// CPrioridadesDlg dialog

CPrioridadesDlg::CPrioridadesDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPrioridadesDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPrioridadesDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPrioridadesDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPrioridadesDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPrioridadesDlg, CDialog)
	//{{AFX_MSG_MAP(CPrioridadesDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PARTIR, OnPartir)
	ON_CBN_SELCHANGE(IDC_CLASSE_PRIORIDADE, OnSelchangeClassePrioridade)
	ON_CBN_SELCHANGE(IDC_PRIORIDADE1, OnSelchangePrioridade1)
	ON_CBN_SELCHANGE(IDC_PRIORIDADE2, OnSelchangePrioridade2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPrioridadesDlg message handlers

BOOL CPrioridadesDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	cbClassePrioridade = (CComboBox *) GetDlgItem (IDC_CLASSE_PRIORIDADE);
	cbClassePrioridade->SetItemHeight (0, 10); 
	
	cbPrioridade1 = (CComboBox *) GetDlgItem (IDC_PRIORIDADE1);	
	cbPrioridade2 = (CComboBox *) GetDlgItem (IDC_PRIORIDADE2);	

  /* obter a classe de prioridade do processo para atualizar o combo */
	ExibePrioridadeProcesso (GetPriorityClass (GetCurrentProcess()/* passar a prioridade do processo como parmetro */));
	
	/*
	  - criar as duas threads
		- passar como parametro o progress que ser atualizado: GetDlgItem (IDC_PROGRESS1) 
	*/
	pThread1 = AfxBeginThread(
		Thread, 
		GetDlgItem (IDC_PROGRESS1), 
		THREAD_PRIORITY_NORMAL,
		0, 
		CREATE_SUSPENDED);
	if (pThread1 == NULL)
		MensagemErro ("Erro ao criar thread1!");
	pThread1 -> m_bAutoDelete = FALSE;
	pThread1 -> ResumeThread();
	hThread1 = pThread1->m_hThread;

	/* obter a prioridade da thread e exib-la*/
	ExibePrioridadeThread1 (GetThreadPriority (hThread1));

	pThread2 = AfxBeginThread(
		Thread, 
		GetDlgItem (IDC_PROGRESS2), 
		THREAD_PRIORITY_NORMAL,
		0, 
		CREATE_SUSPENDED);
	if (pThread2 == NULL)
		MensagemErro ("Erro ao criar thread2!");
	pThread2 -> m_bAutoDelete = FALSE;
	pThread2 -> ResumeThread();
	hThread2 = pThread2->m_hThread;
	/* obter a prioridade da thread e exib-la*/
	ExibePrioridadeThread2 (GetThreadPriority (hThread2));


	/* mudar a prioridade da thread primaria */
	SetThreadPriority (GetCurrentThread (), THREAD_PRIORITY_HIGHEST);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPrioridadesDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPrioridadesDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CPrioridadesDlg::ExibePrioridadeProcesso (DWORD dwPrioridade)
{
	switch (dwPrioridade)
	{
		case REALTIME_PRIORITY_CLASS:
			cbClassePrioridade->SetCurSel (0);
			break;
		case HIGH_PRIORITY_CLASS: 
			cbClassePrioridade->SetCurSel (1);
			break;
 
    case NORMAL_PRIORITY_CLASS:
			cbClassePrioridade->SetCurSel (2);
			break;

		case IDLE_PRIORITY_CLASS:
			cbClassePrioridade->SetCurSel (3);
			break;
	}
}


void CPrioridadesDlg::ExibePrioridadeThread1 (int dwPrioridade)
{
	switch (dwPrioridade)
	{
		case THREAD_PRIORITY_TIME_CRITICAL :
			cbPrioridade1->SetCurSel (0);
			break;

		case THREAD_PRIORITY_HIGHEST:
			cbPrioridade1->SetCurSel (1);
			break;

		case THREAD_PRIORITY_ABOVE_NORMAL:
			cbPrioridade1->SetCurSel (2);
			break;

		case THREAD_PRIORITY_NORMAL:
			cbPrioridade1->SetCurSel (3);
			break;

		case THREAD_PRIORITY_BELOW_NORMAL:
			cbPrioridade1->SetCurSel (4);
			break;

		case THREAD_PRIORITY_LOWEST:
			cbPrioridade1->SetCurSel (5);
			break;

		case THREAD_PRIORITY_IDLE:
			cbPrioridade1->SetCurSel (6);
			break;
	}
}

void CPrioridadesDlg::ExibePrioridadeThread2 (int dwPrioridade)
{
	switch (dwPrioridade)
	{
		case THREAD_PRIORITY_TIME_CRITICAL :
			cbPrioridade2->SetCurSel (0);
			break;

		case THREAD_PRIORITY_HIGHEST:
			cbPrioridade2->SetCurSel (1);
			break;

		case THREAD_PRIORITY_ABOVE_NORMAL:
			cbPrioridade2->SetCurSel (2);
			break;

		case THREAD_PRIORITY_NORMAL:
			cbPrioridade2->SetCurSel (3);
			break;

		case THREAD_PRIORITY_BELOW_NORMAL:
			cbPrioridade2->SetCurSel (4);
			break;

		case THREAD_PRIORITY_LOWEST:
			cbPrioridade2->SetCurSel (5);
			break;

		case THREAD_PRIORITY_IDLE:
			cbPrioridade2->SetCurSel (6);
			break;
	}
}


void CPrioridadesDlg::ExibePrioridadeThreadPrimaria (int dwPrioridade)
{
	switch (dwPrioridade)
	{
		case THREAD_PRIORITY_TIME_CRITICAL :
			cbPrioridadePrimaria->SetCurSel (0);
			break;

		case THREAD_PRIORITY_HIGHEST:
			cbPrioridadePrimaria->SetCurSel (1);
			break;

		case THREAD_PRIORITY_ABOVE_NORMAL:
			cbPrioridadePrimaria->SetCurSel (2);
			break;

		case THREAD_PRIORITY_NORMAL:
			cbPrioridadePrimaria->SetCurSel (3);
			break;

		case THREAD_PRIORITY_BELOW_NORMAL:
			cbPrioridadePrimaria->SetCurSel (4);
			break;

		case THREAD_PRIORITY_LOWEST:
			cbPrioridadePrimaria->SetCurSel (5);
			break;

		case THREAD_PRIORITY_IDLE:
			cbPrioridadePrimaria->SetCurSel (6);
			break;
	}
}


/* Thread que ser criada para fazer clculos */
UINT Thread (LPVOID Param)
{
	CProgressCtrl * Progress;
	int i, j;

	Progress = (CProgressCtrl *) Param;

	Progress->SetRange (0, 10);
	Progress->SetStep (1);

	while (TRUE)
	{
		/* supender a prpria execuo, para aguardar pelo comando do usurio */
		SuspendThread (GetCurrentThread());
		
		Progress->SetPos (0);

		/* entra no loop para realizar contas */
		for (i = 0; i < 10; i ++)
		{
			for (j =0; j < 1000000; j ++)
				sin (j);
			Progress->StepIt ();
			
		}
	}
	return 0;
}


void MensagemErro (char * szMsg)
{
	char szMsgErro[200];
	sprintf (szMsgErro, "%s: %d", szMsg, GetLastError());
	AfxMessageBox (szMsgErro);
}

void CPrioridadesDlg::OnPartir() 
{
	/* resumir a execuo das threads */
	pThread1->ResumeThread();
	pThread2->ResumeThread();
}


void CPrioridadesDlg::OnSelchangeClassePrioridade() 
{
	DWORD dwPrioridade;

	switch (cbClassePrioridade->GetCurSel())
	{
		case 0:
			dwPrioridade = REALTIME_PRIORITY_CLASS;
			break;

		case 1:
			dwPrioridade = HIGH_PRIORITY_CLASS;
			break;

		case 2:
			dwPrioridade = NORMAL_PRIORITY_CLASS;
			break;

		case 3:
			dwPrioridade = IDLE_PRIORITY_CLASS;
			break;
	}

	// modificar a classe de prioridade (a prioridade est na varivel dwPrioridade)
  SetPriorityClass (GetCurrentProcess(), dwPrioridade);
}


void CPrioridadesDlg::OnSelchangePrioridade1() 
{
	DWORD dwPrioridade;

	switch (cbPrioridade1->GetCurSel())
	{
		case 0:
			dwPrioridade = THREAD_PRIORITY_TIME_CRITICAL;
			break;

		case 1:
			dwPrioridade = THREAD_PRIORITY_HIGHEST;
			break;

		case 2:
			dwPrioridade = THREAD_PRIORITY_ABOVE_NORMAL;
			break;

		case 3:
			dwPrioridade = THREAD_PRIORITY_NORMAL;
			break;

		case 4:
			dwPrioridade = THREAD_PRIORITY_BELOW_NORMAL;
			break;

		case 5:
			dwPrioridade = THREAD_PRIORITY_LOWEST;
			break;

		case 6:
			dwPrioridade = THREAD_PRIORITY_IDLE;
			break;
	}

	/* mudar a prioridade da thread (est em dwPrioridade) */
	SetThreadPriority (hThread1, dwPrioridade);
}

void CPrioridadesDlg::OnSelchangePrioridade2() 
{
	DWORD dwPrioridade;

	switch (cbPrioridade2->GetCurSel())
	{
		case 0:
			dwPrioridade = THREAD_PRIORITY_TIME_CRITICAL;
			break;

		case 1:
			dwPrioridade = THREAD_PRIORITY_HIGHEST;
			break;

		case 2:
			dwPrioridade = THREAD_PRIORITY_ABOVE_NORMAL;
			break;

		case 3:
			dwPrioridade = THREAD_PRIORITY_NORMAL;
			break;

		case 4:
			dwPrioridade = THREAD_PRIORITY_BELOW_NORMAL;
			break;

		case 5:
			dwPrioridade = THREAD_PRIORITY_LOWEST;
			break;

		case 6:
			dwPrioridade = THREAD_PRIORITY_IDLE;
			break;
	}

	/* mudar a prioridade da thread (est em dwPrioridade) */
	SetThreadPriority (hThread2, dwPrioridade);
}
