//
//	Programao Multithreaded em ambiente Windows NT - uma viso de  Automao
// 
//	Autores: Constantino Seixas Filho/ Marcelo Szuster
//
//	Captulo 6 - Exemplo 1	- Dump de arquivos
//
//	Verso: 1.2	25/12/1999
//

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>		// _getch()

#define _CHECKERROR	1	// Ativa funo CheckForError
#include "CheckForError.h"

#define	ESC		0x1B

void ShowDump(char *, int);

int main()
{
	DWORD dwExitCode = 0;
	char MyBuffer[512];	// Buffer de leitura 
	char FileName[40];
	int iBloco;			// iBloco de memria de 512 caracteres
	HANDLE hFile;
	DWORD dwBytesRead;
	BOOL bStatus;
	DWORD dwRegLength;
	char cTecla;
	LONG lFilePosLow=0L;
	BOOL bEndOfFile;		// Fim de arquivo alcanado.


	printf("\nEntre com nome do arquivo: ");
	scanf("%s", FileName);
	hFile= CreateFile(FileName,
		GENERIC_READ|GENERIC_WRITE,
		FILE_SHARE_READ|FILE_SHARE_WRITE, // abre para leitura e escrita
		NULL,		// atributos de segurana 
		OPEN_EXISTING,// abre se existir 
		FILE_ATTRIBUTE_NORMAL,
		NULL);		// Template para atributos e flags
	CheckForError(hFile != INVALID_HANDLE_VALUE);
	
	iBloco = 0;
	dwRegLength = 128L;
	// Le registro desejado
	do {
		lFilePosLow = SetFilePointer(hFile,lFilePosLow,NULL,FILE_BEGIN);
		bStatus = ReadFile(hFile, &MyBuffer, dwRegLength, &dwBytesRead, NULL);
		CheckForError(bStatus);
		bEndOfFile = (dwBytesRead != dwRegLength)? TRUE: FALSE; 
		printf("\nBloco = %d  Offset = %d\n", iBloco, lFilePosLow);
		ShowDump(MyBuffer, (int)dwBytesRead);
		do 
			cTecla = _getch();
		while ((cTecla != ESC) && (cTecla != '+') && (cTecla != '-'));
	
		if (cTecla == ESC) break;
		if ((cTecla == '+') && (!bEndOfFile)) { lFilePosLow += dwRegLength; iBloco++; }
		if ((cTecla == '-') && (iBloco >0))	{ lFilePosLow -= dwRegLength; iBloco--; }
	} while (1);

	CloseHandle(hFile);

	printf("\nAperte uma tecla...\n");
	_getch();

	return EXIT_SUCCESS;
}	// main



void ShowDump(char *lpBuffer, int iLength)
{	int i=0;
	int iColuna;
	int iLinha;
	int iLinhas;
	int iResto;

	iLinhas = iLength / 16;
	iResto = iLength %  16;
	
	// Imprime cabealho
	printf("\n00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F  0 1 2 3 4 5 6 7 8 9 A B C D E F\n");
	printf("================================================================================\n");

	for (iLinha=0; iLinha<iLinhas; iLinha++)
	{	for (iColuna=0; iColuna<16; ++iColuna)
			printf("%02x ", lpBuffer[i++] & 0xFF);
		i-= 16;
		printf(" ");
		for (iColuna=0; iColuna<16; ++iColuna)
			if (isprint(lpBuffer[i]))
				printf("%c ", lpBuffer[i++]);
			else { printf(". "); i++; }
		printf("\n");
	}  // for

	if (iResto > 0) {
		// printa ltima linha
		for (iColuna=0; iColuna<16; ++iColuna)
			if (iColuna < iResto) printf("%02x ", lpBuffer[i++] & 0xFF);
			else printf("   "); 
		i-= iResto;
		printf(" ");
		for (iColuna=0; iColuna<iResto; ++iColuna)
			if (isprint(lpBuffer[i]))
				printf("%c ", lpBuffer[i++]);
				else { printf(". "); i++; }
		printf("\n\n");
	}

} // show_dump

