//
//	Programao Multithreaded em ambiente Windows NT - uma viso de  Automao
// 
//	Autores: Constantino Seixas Filho/ Marcelo Szuster
//
//	Captulo 6 - Exemplo 2	- Pipes No Nomeados
//
//	Verso: 1.1	25/12/1999
//


#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>		// _getch()
#include "Exemplo62.h"


#define	_CHECKERROR			1	// Ativa funo CheckForError
#include "CheckForError.h"

#define	ESC		0x1B

int main()
{
	char FileName[50];
	int iBloco;					// Bloco de memria de 512 caracteres
	DWORD dwBytesRead;
	DWORD dwBytesWritten;
	DWORD dwRegLength;			// Tamanho do registro a ser lido do arquivo em bytes
	LONG lFilePosLow=0L;		// Offset dentro do arquivo
	BOOL bStatus;
	PROCESS_INFORMATION NewProcess;	// Informaes sobre novo processo criado
	int iTecla;
	STARTUPINFO si;				// StartUpInformation para novo processo
	char LinhaDeComando[30];
	FileReadDesc DumpRequest; 
	DumpFileAck DumpAck;

	// Handles do pipe no sentido Cliente Servidor
	HANDLE hCSReadPipe;		// Handle para operaes de leitura
	HANDLE hCSWritePipe;	// Handle para operaes de escrita
	// Handles do pipe no sentido Sevidor Cliente
	HANDLE hSCReadPipe;		// Handle para operaes de leitura
	HANDLE hSCWritePipe;	// Handle para operaes de escrita

	// Cria pipe no nomeado no sentido Cliente Servidor
	bStatus=CreatePipe(&hCSReadPipe, &hCSWritePipe, 
		NULL,	// lpPipeAttributes
		0);		// tamanho do bufferCreatePipe();
	CheckForError(bStatus);

	// Cria pipe no nomeado no sentido Servidor Cliente
	bStatus=CreatePipe(&hSCReadPipe, &hSCWritePipe, 
		NULL,	// lpPipeAttributes
		0);		// tamanho do bufferCreatePipe();
	CheckForError(bStatus);

	// printf("\nHandles: hCSRead=%d hCSWrite = %d hSCRead=%d hSCWrite=%d\n", hCSReadPipe, hCSWritePipe, hSCReadPipe, hSCWritePipe);

	// Cria processo servidor
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);	// Tamanho da estrutura em bytes
	sprintf(LinhaDeComando, "%u %u %u", GetCurrentProcessId(), hCSReadPipe, hSCWritePipe);
	bStatus = CreateProcess(
		"c:\\Livro\\Programas\\Prog62Server\\Debug\\Programa62Server.exe", // Nome
		LinhaDeComando,	// linha de comando: Passa id do processo como parmetro
		NULL,	// atributos de segurana: Processo
		NULL,	// atributos de segurana: Thread
		FALSE,	// herana de handles
		NORMAL_PRIORITY_CLASS,	// CreationFlags
		NULL,	// lpEnvironment
		"c:\\Livro\\Programas\\Prog62Server\\Debug",	// diretrio corrente do filho
		&si,			// lpStartUpInfo
		&NewProcess);	// lpProcessInformation
	CheckForError(bStatus);

	// printf("NewProcessId= %u  NewThreadId= %u\n", NewProcess.dwProcessId, NewProcess.dwThreadId);

	// Interage com o usurio
	printf("\nDump de Arquivos: ");
	printf("\nEntre com nome do arquivo: ");
	scanf("%s", FileName);

	iBloco = 0;
	dwRegLength = 128L;
	strcpy(DumpRequest.FileName, FileName);
	DumpRequest.Length = dwRegLength;

	do {
		DumpRequest.InitialPosition = iBloco * dwRegLength;
		// Envia dados dos pedidos
		WriteFile(hCSWritePipe, &DumpRequest, sizeof(DumpRequest), &dwBytesWritten, NULL);
		// Recebe acknowledge da transao
		ReadFile(hSCReadPipe, &DumpAck, sizeof(DumpAck), &dwBytesRead, NULL); 
		if (DumpAck.Erro > 0) {
			if (DumpAck.Erro == ERRO_ARQUIVO_INEXISTENTE) 
				 printf("\nArquivo Inexistente\n");
			else printf("\nErro na operacao com o arquivo\n");
			Sleep(3000);
			break;
		}
		printf("Client: Bytes Read = %d EOF=%d \n", DumpAck.BytesRead, DumpAck.EndOfFile);
		
		do 
			iTecla = _getch();
		while ((iTecla != ESC) && (iTecla != '+') && (iTecla != '-'));
	
		if ((iTecla == '+') && (!DumpAck.EndOfFile)) { lFilePosLow += dwRegLength; iBloco++; }
		if ((iTecla == '-') && (iBloco >0)) { lFilePosLow -= dwRegLength; iBloco--; }
		if (iTecla == ESC) {
			DumpRequest.Length = 0;	// Flag para abortar servidor
			WriteFile(hCSWritePipe, &DumpRequest, sizeof(DumpRequest), &dwBytesWritten, NULL);
			break;
		} // if
	} while (1);

	CloseHandle(hCSWritePipe);
	CloseHandle(hSCReadPipe);	

	// Aposto que voc se esqueceu destes handles!!!
	CloseHandle(NewProcess.hProcess);
	CloseHandle(NewProcess.hThread);
	
	printf("\nAperte uma tecla...\n");
	_getch();
	
	ExitProcess(0);
	return EXIT_SUCCESS;
}	// main


