//
//	Programao Multithreaded em ambiente Windows NT - uma viso de  Automao
// 
//	Autores: Constantino Seixas Filho/ Marcelo Szuster
//
//	Captulo 6 - Exemplo 3	- Pipes Nomeados
//
//	Verso: 1.1	17/12/1999
//

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>		// _getch()

#include "Exemplo62.h"
#include "bGetString.h"
#include "GetOSVersion.h"

#define	_CHECKERROR			1	// Ativa funo CheckForError
#include "CheckForError.h"

#define	ESC		0x1B

int main()
{
	char FileName[50];
	int iBloco;					// Bloco de memria de 512 caracteres
	DWORD dwBytesRead;
	DWORD dwBytesWritten;
	DWORD dwRegLength;			// Tamanho do registro a ser lido do arquivo em bytes
	LONG lFilePosLow=0L;		// Offset dentro do arquivo
	BOOL Status;
	PROCESS_INFORMATION NewProcess;	// Informaes sobre novo processo criado
	int iTecla;
	STARTUPINFO si;				// StartUpInformation para novo processo
	FileReadDesc DumpRequest; 
	DumpFileAck DumpAck;
	BOOL bResult;
	HANDLE hPipe;
	LPTSTR lpszPipename = "\\\\.\\pipe\\Pipe63";
	int iProc;		// Nmero de processadores
	char strVer[30];// Verso do sistema operacional
	BOOL bRet;

	bRet = GetOSVersion(strVer, &iProc);
	printf("Versao do SO = %s  Processadores = %d\n", strVer, iProc);
	if (!bRet) { // No  NT. No  NT ...
		printf("Falha: Sistema operacional NAO E O NT\n");
		printf("\nAcione uma tecla para terminar\n");
		_getch(); // // Pare aqui, caso no esteja executando no ambiente MDS
		return 0;
	} // if

	// Cria processo servidor. Poderia ter sido criado a partir da linha de comando
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);	// Tamanho da estrutura em bytes
	Status = CreateProcess(
		"c:\\Livro\\Programas\\Programa63Server\\Debug\\Programa63Server.exe", // Nome
		NULL,	// linha de comando: Passa id do processo como parmetro
		NULL,	// atributos de segurana: Processo
		NULL,	// atributos de segurana: Thread
		FALSE,	// herana de handles
		NORMAL_PRIORITY_CLASS,	// CreationFlags
		NULL,	// lpEnvironment
		"c:\\Livro\\Programas\\Programa63Server\\Debug",	// diretrio corrente do filho
		&si,			// lpStartUpInfo
		&NewProcess);	// lpProcessInformation
	CheckForError(Status);

    while (1) // Espera conexo
    { 
	  hPipe = CreateFile( 
         lpszPipename,   // nome do pipe 
         GENERIC_READ |  // acesso para leitura e escrita 
         GENERIC_WRITE, 
         0,              // sem compartilhamento 
         NULL,           // lpSecurityAttributes
         OPEN_EXISTING,  // dwCreationDistribution 
         0,              // dwFlagsAndAttributes 
         NULL);          // hTemplate
	   //CheckForError(hPipe != INVALID_HANDLE_VALUE);

	   // Se o handle  vlido pode usar o pipe
       if (hPipe != INVALID_HANDLE_VALUE) 
		   break;
	  
      // Todas as instancias esto ocupadas, ento espere pelo tempo default 
       if (WaitNamedPipe(lpszPipename, NMPWAIT_USE_DEFAULT_WAIT) == 0) 
        	printf("\nEsperando por uma instancia do pipe..."); // Temporizao abortada: o pipe ainda no foi criado
	   
    } // while

	do {
		// Interage com o usurio
		printf("\nDump de Arquivos: ");
		printf("\nEntre com nome do arquivo: ");
		bResult = bGetString(FileName, 30);
		if (!bResult) {  // Acionou Escape
			DumpRequest.Length = 0;	// Flag para abortar servidor
			WriteFile(hPipe, &DumpRequest, sizeof(DumpRequest), &dwBytesWritten, NULL);
			printf("\n");
			break; // Termina o programa
		}

		iBloco = 0;
		dwRegLength = 128L;
		strcpy(DumpRequest.FileName, FileName);
		DumpRequest.Length = dwRegLength;

		do {
			DumpRequest.InitialPosition = iBloco * dwRegLength;
			// Envia dados dos pedidos
			WriteFile(hPipe, &DumpRequest, sizeof(DumpRequest), &dwBytesWritten, NULL);
			// Recebe acknowledge da transao
			ReadFile(hPipe, &DumpAck, sizeof(DumpAck), &dwBytesRead, NULL); 
			if (DumpAck.Erro > 0) {
				if (DumpAck.Erro == ERRO_ARQUIVO_INEXISTENTE) 
					 printf("\nArquivo Inexistente\n");
				else printf("\nErro na operacao com o arquivo\n");
				break;
			} // if

			printf("Client: Bytes Read = %d EOF=%d \n", DumpAck.BytesRead, DumpAck.EndOfFile);
		
			do 
				iTecla = _getch();
			while ((iTecla != ESC) && (iTecla != '+') && (iTecla != '-'));
	
			if ((iTecla == '+') && (!DumpAck.EndOfFile)) { lFilePosLow += dwRegLength; iBloco++; }
			if ((iTecla == '-') && (iBloco >0)) { lFilePosLow -= dwRegLength; iBloco--; }
			if (iTecla == ESC) break;  // Volta  linha de comando
			
		} while (1);
	} while (1);

	CloseHandle(hPipe);

	// Aposto que voc se esqueceu destes handles!!!
	CloseHandle(NewProcess.hProcess);
	CloseHandle(NewProcess.hThread);	
	
	printf("\nAperte uma tecla...\n");
	_getch();
	
	ExitProcess(0);
	return EXIT_SUCCESS;
}	// main


