//
//	Programao Multithreaded em ambiente Windows NT - uma viso de  Automao
// 
//	Autores: Constantino Seixas Filho/ Marcelo Szuster
//
//	Captulo 6 - Exemplo 3	- Pipes Nomeados - Servidor
//
//	SERVIDOR: PRG63SERVER.CPP
//
//	Verso: 1.1	15/12/1999
//

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "Exemplo62.h"
#include "ShowDump.h"

#define _CHECKERROR	1	// Ativa funo CheckForError
#include "CheckForError.h"

void ShowDump(char *, int);

int main()						// Receber id do processo pai como parmetro
{								// e handles para os dois pipes
	char FileName[50]= "";		// Nome do arquivo a ser lido
	HANDLE hFile= 0;			// Handle para arquivo a ser aberto
	DWORD dwBytesRead;		
	DWORD dwBytesWritten;	
	LONG lFilePosLow=0L;			// Offset para posicao corrente do arquivo
	BOOL bStatus;
	char MyBuffer[512];			// Buffer para leitura do arquivo
	FileReadDesc DumpRequest;	// Descritor do pedido de leitura 
	DumpFileAck DumpAck;		// Resposta do servidor para cliente
	DWORD dwLength;
	HANDLE hPipe;				// Handle para o pipe nomeado
	DWORD dwErrorCode;			// Cdigo de erro retornado por GetLastError()

	// S funciona no Windows NT
	// Cria instncia de um pipe: neste caso s uma
	hPipe = CreateNamedPipe(
		"\\\\.\\pipe\\Pipe63",
		PIPE_ACCESS_DUPLEX,	// Comunicao Full Duplex
		PIPE_TYPE_MESSAGE | PIPE_READMODE_MESSAGE | PIPE_WAIT,
		1,			// Nmero de instncias
		0,			// nOutBufferSize
		0,			// nInBufferSize
		1000,		// Timeout default para esperar por cliente
		NULL);		// Atributos de segurana
	CheckForError(hPipe != INVALID_HANDLE_VALUE);

	bStatus = ConnectNamedPipe(hPipe, NULL); // Fica preso esperando conexo
	if (bStatus) {
		printf("\nCliente se conectou com sucesso");
	}
	else {
		dwErrorCode = GetLastError();
		if (dwErrorCode == ERROR_PIPE_CONNECTED) {
			printf("\nCliente j havia se conectado");
		}  // if
		else if (dwErrorCode == ERROR_NO_DATA) {
				printf("\nCliente fechou seu handle");
				return 0;
			} // if
			else CheckForError(FALSE);
	}  // else
		
	do {
		// Recebe pedido de dump via pipe
		bStatus=ReadFile(hPipe, &DumpRequest, sizeof(DumpRequest), &dwBytesRead, NULL);
		CheckForError(bStatus);

		lFilePosLow = DumpRequest.InitialPosition;
		dwLength = DumpRequest.Length;
		
		if (dwLength==0) break;	// Flag para abortar processo servidor
		
		if (strcmp(FileName, DumpRequest.FileName) != 0) { 
			strcpy(FileName, DumpRequest.FileName);
			printf("FileName=%s", FileName);
			// Abre novo arquivo
			if (hFile != 0) CloseHandle(hFile); 
			hFile= CreateFile(
				FileName,
				GENERIC_READ,
				FILE_SHARE_READ,	// abre para leitura e escrita
				NULL,				// atributos de segurana 
				OPEN_EXISTING,		// abre se existir 
				FILE_ATTRIBUTE_NORMAL,
				NULL);				// Template para atributos e flags
			CheckForError(hFile != INVALID_HANDLE_VALUE);

			if (hFile == INVALID_HANDLE_VALUE) {
				DumpAck.Erro = ERRO_ARQUIVO_INEXISTENTE;
				// Envia Nack para Cliente
				WriteFile(hPipe, &DumpAck, sizeof(DumpAck), &dwBytesWritten, NULL);
				continue; // volta ao loop de espera de nome de arquivo		
			} // if
		} // if
		else if (hFile == INVALID_HANDLE_VALUE) { // Nome permanesce errado
				DumpAck.Erro = ERRO_ARQUIVO_INEXISTENTE;
				// Envia Nack para Cliente
				WriteFile(hPipe, &DumpAck, sizeof(DumpAck), &dwBytesWritten, NULL);
				continue; // Arquivo no existe
				}
		
		// Le registro desejado
		lFilePosLow = SetFilePointer(hFile,lFilePosLow,NULL,FILE_BEGIN);
		bStatus = ReadFile(hFile, &MyBuffer, dwLength, &dwBytesRead, NULL);
		CheckForError(bStatus);
		DumpAck.EndOfFile = (dwBytesRead != dwLength)? TRUE: FALSE;
	
		ShowDump(MyBuffer, (int)dwBytesRead);
		
		// Envia bStatus da leitura para processo cliente
		DumpAck.BytesRead = dwBytesRead;
		DumpAck.Erro = 0;
		
		// Envia Acknowledge para Cliente
		WriteFile(hPipe, &DumpAck, sizeof(DumpAck), &dwBytesWritten, NULL);
	
	} while (1);

	CloseHandle(hFile);	
	CloseHandle(hPipe);
	return EXIT_SUCCESS;
}	// main


