//
//	Programao Multithreaded em ambiente Windows NT - uma viso de  Automao
// 
//	Autores: Constantino Seixas Filho/ Marcelo Szuster
//
//	Captulo 6 - Exemplo 4	- Mailslot
//
//	Verso: 1.1	13/03/1999
//

#define WNT_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>		// _getch()
#include "Exemplo64.h"


#define	_CHECKERROR			1	// Ativa funo CheckForError
#include "CheckForError.h"

#define	ESC		0x1B

AlarmMsg FormatMsg(DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, 
		Quality, double, char *, char *, char *);

int main()
{
	int iTecla;
	HANDLE hMailslot;
	HANDLE hEvent;
	AlarmMsg Msg;
	BOOL bStatus;
	DWORD dwBytesEnviados;
	STARTUPINFO si;			// StartUpInformation para novo processo
	PROCESS_INFORMATION NewProcess;	// Informaes sobre novo processo criado
	
	// Cria um objeto do tipo evento para sincronizar dois processos
	// O evento ser sinalizado quando o servidor tiver criado o mailslot
    hEvent = CreateEvent(NULL, TRUE, FALSE, "Prog64");
 
	// Cria processo servidor
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);	// Tamanho da estrutura em bytes

	bStatus = CreateProcess(
		"c:\\Livro\\Programas\\Prog64Server\\Debug\\Programa64Server.exe", // Nome
		NULL,	// linha de comando
		NULL,	// atributos de segurana: Processo
		NULL,	// atributos de segurana: Thread
		FALSE,	// herana de handles
		NORMAL_PRIORITY_CLASS,	// CreationFlags
		NULL,	// lpEnvironment
		"c:\\Livro\\Programas\\Prog64Server\\Debug",	// diretrio corrente do filho
		&si,			// lpStartUpInfo
		&NewProcess);	// lpProcessInformation
	CheckForError(bStatus);

	// Espera sincronismo para servidor e mailslot serem criados
    WaitForSingleObject(hEvent, INFINITE);

	hMailslot = CreateFile("\\\\.\\mailslot\\Livro\\Programas\\Programa64\\MyMailslot",
		GENERIC_WRITE, 
		FILE_SHARE_READ, 
		NULL, 
		OPEN_EXISTING, 
		FILE_ATTRIBUTE_NORMAL, 
		NULL);
	CheckForError(hMailslot != INVALID_HANDLE_VALUE);

	Msg = FormatMsg(14, 03, 1999, 9, 31, 0, 345, GOOD, 58.345, "14-TT-02", "Temperatura de Escaldagem", "ALTA"); 
	bStatus = WriteFile(hMailslot, &Msg, sizeof(AlarmMsg), &dwBytesEnviados, NULL);
	printf("Bytes enviados= %d\n", dwBytesEnviados);
	printf("Acione uma tecla para nova mensagem de alarme\n");
	iTecla = _getch();

	Msg = FormatMsg(14, 03, 1999, 9, 32, 3, 500, NOT_RELIABLE, 1.345, "21-WT-02", "Peso Fora de faixa", "BAIXO"); 
	bStatus = WriteFile(hMailslot, &Msg, sizeof(AlarmMsg), &dwBytesEnviados, NULL);
	iTecla = _getch();

	Msg = FormatMsg(15, 03, 1999, 18, 22, 12, 12, GOOD, 1, "21-TC-04DEF", "Chave de desalinhamento", "ATUADO"); 
	bStatus = WriteFile(hMailslot, &Msg, sizeof(AlarmMsg), &dwBytesEnviados, NULL);
	iTecla = _getch();

	// Envia Mensagem para abortar o servidor
	Msg = FormatMsg(0, 0, 0, 0, 0, 0, 0, ABORT, 0., "", "", ""); 
	bStatus = WriteFile(hMailslot, &Msg, sizeof(AlarmMsg), &dwBytesEnviados, NULL);
	
	CloseHandle(hMailslot);
	CloseHandle(hEvent);
	CloseHandle(NewProcess.hProcess);
	CloseHandle(NewProcess.hThread);

	printf("\nAperte uma tecla...\n");
	_getch();
	
	ExitProcess(0);
	return EXIT_SUCCESS;
}	// main


AlarmMsg FormatMsg(DWORD dwDia, DWORD dwMes, DWORD dwAno, 
	DWORD dwHora, DWORD dwMinuto, DWORD dwSegundo, DWORD dwMs, 
	Quality Q, double dValue, char *lpTag, char *lpDescr, char *lpStatus)
{
	AlarmMsg Msg;

	Msg.TimeStp.Date.Dia= dwDia;
	Msg.TimeStp.Date.Mes= dwMes;
	Msg.TimeStp.Date.Ano= dwAno;
	Msg.TimeStp.Time.Hora= dwHora;
	Msg.TimeStp.Time.Min= dwMinuto;
	Msg.TimeStp.Time.Seg= dwSegundo;
	Msg.TimeStp.Time.Ms= dwMs;
	Msg.Q= Q;
	Msg.Value= dValue;
	strcpy((char *) &Msg.Tag, lpTag);
	strcpy((char *) &Msg.Description, lpDescr);
	strcpy((char *) &Msg.Status, lpStatus);

	return Msg;
} // FormatMsg

