//
//	Programao Multithreaded em ambiente Windows NT - uma viso de  Automao
// 
//	Autores: Constantino Seixas Filho/ Marcelo Szuster
//
//	Captulo 6 - Exemplo 4	- Mailslots - Servidor
//
//	SERVIDOR: PRG54SERVER.CPP
//
//	Verso: 1.1	13/03/1999
//

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "Exemplo64.h"

#define _CHECKERROR	1	// Ativa funo CheckForError
#include "CheckForError.h"


// As estrutura definidas so ineficientes mas so mais fceis de se decodificar


void ShowAlarm(AlarmMsg, DWORD);

int main()						
{	
	DWORD dwAlarmCont = 0;	// contador de mensagem de alarmes
	AlarmMsg MsgBuffer;
	HANDLE hMailslot;
	BOOL bStatus;
	DWORD dwBytesLidos;
	HANDLE hEvent;

	hEvent=OpenEvent(EVENT_MODIFY_STATE, FALSE, "Prog64");

	hMailslot= CreateMailslot(
		"\\\\.\\mailslot\\Livro\\Programas\\Programa64\\MyMailslot",
		0,
		MAILSLOT_WAIT_FOREVER,
		NULL);
	CheckForError(hMailslot != INVALID_HANDLE_VALUE);

	// Avisa que est apto a receber mensagens
    SetEvent(hEvent);

	if (hMailslot != INVALID_HANDLE_VALUE) 
	do {

#ifdef TEST_GET_MAILSLOT_INFO
	
		DWORD MaxMsgSize;
		DWORD NextMsgSize;
		DWORD MsgCont;
		DWORD Timeout;

		bStatus=GetMailslotInfo(hMailslot,&MaxMsgSize,&NextMsgSize,
		&MsgCont,&Timeout);
		CheckForError(bStatus);
		printf("NextMsgSize= %d\n", MaxMsgSize);
#endif

		bStatus=ReadFile(hMailslot, &MsgBuffer, sizeof(AlarmMsg), &dwBytesLidos, NULL);
		CheckForError(bStatus);
			
		if (MsgBuffer.Q == ABORT) break; // aborta servidor
		
		ShowAlarm(MsgBuffer, dwAlarmCont++);
	
	} while (1);
	
	CloseHandle(hEvent);
	CloseHandle(hMailslot);	
	return EXIT_SUCCESS;
}	// main


void ShowAlarm(AlarmMsg Msg, DWORD dwAlarmCont)
{	
	char *QualityMsg[]= {"INVALID","GOOD","NOT_RELIABLE","FORA DE FAIXA"};
	char Quality[15];

	if ((dwAlarmCont % 16) ==0) {
		// Imprime cabealho
		printf("\n			Registro de alarmes\n");
		printf("===============================================================================\n");
		printf("   DATA        HORA      VARIAVEL VALOR  QUALIDADE     DESCRICAO         STATUS\n");
		//      13/03/1999 14:02:54:0673 21-WT-45 1245.93 GOOD  Temperatura do Forno      ALTA
	}
	
	if (Msg.Q < 3) 
	  strcpy(Quality, QualityMsg[Msg.Q]);
	else strcpy(Quality, QualityMsg[3]);

	printf("%02d/%02d/%4d %02d:%02d:%02d:%04d %8.8s %6.2f %-12.12s %-20.20s %-4.4s\n",
	Msg.TimeStp.Date.Dia, Msg.TimeStp.Date.Mes, Msg.TimeStp.Date.Ano, 
	Msg.TimeStp.Time.Hora, Msg.TimeStp.Time.Min, Msg.TimeStp.Time.Seg, Msg.TimeStp.Time.Ms,
	Msg.Tag,
	Msg.Value,
	Quality,
	Msg.Description,
	Msg.Status);
} // ShowAlarm

