//
//	Programao Multithreaded em ambiente Windows NT - uma viso de  Automao
// 
//	Autores: Constantino Seixas Filho/ Marcelo Szuster
//
//	Captulo 6 - Exemplo 5	- Memria Compartilhada
//
//	Verso: 1.2	25/12/1999
//


#define WNT_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MSG_SIZE	20

#define	_CHECKERROR			1	// Ativa funo CheckForError
#include "CheckForError.h"


int main()
{
	BOOL bStatus;
	char *lpImage;			// Apontador para imagem local
	HANDLE hSection;
	HANDLE hEventSent;
	HANDLE hEventRead;
			
	
	hSection= OpenFileMapping(
		FILE_MAP_ALL_ACCESS,
		FALSE,				// Handle herdvel
		"MADONNA");			// Escolha o seu nome preferido
	CheckForError(hSection);

	lpImage= (char *)MapViewOfFile(
		hSection,
		FILE_MAP_WRITE,		// Direitos de acesso: leitura e escrita
		0,					// dwOffsetHigh
		0,					// dwOffset Low
		MSG_SIZE);			// Nmero de bytes a serem mapeados
	CheckForError(lpImage);
	
	// Abre eventos criados por Processo65
	hEventSent= OpenEvent(EVENT_ALL_ACCESS, FALSE, "MsgAvailable");
	CheckForError(hEventSent);

	// Cria evento com reset automtico
	hEventRead= OpenEvent(EVENT_ALL_ACCESS, FALSE, "MsgRead");
	CheckForError(hEventRead);

	do {
		// Espera que processo A escreva mensagem 
		WaitForSingleObject(hEventSent, INFINITE);
		ResetEvent(hEventSent);
		printf("Mensagem Recebida= %s\n", lpImage);
		if (strcmp(lpImage, "")==0) break;

		// Limpa memria compartilhada
		strcpy(lpImage, "");	
		SetEvent(hEventRead);	// Avisa processo A	
 
	} while(TRUE);

	// Elimina mapeamento
	bStatus=UnmapViewOfFile(lpImage);
	CheckForError(bStatus);

	CloseHandle(hSection);
	CloseHandle(hEventSent);
	CloseHandle(hEventRead);
	
	ExitProcess(0);
	return EXIT_SUCCESS;
}	// main


