//
//	Programao Multithreaded em ambiente Windows NT - uma viso de  Automao
// 
//	Autores: Constantino Seixas Filho/ Marcelo Szuster
//
//	Captulo 6 - Exemplo 5	- Memria Compartilhada
//
//	Verso: 1.1	21/03/1999
//


#define WNT_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MSG_SIZE	20

#define	_CHECKERROR			1	// Ativa funo CheckForError
#include "CheckForError.h"

#include "bGetString.h"


int main()
{
	DWORD dwExitCode = 0;
	BOOL bStatus;
	STARTUPINFO si;			// StartUpInformation para novo processo
	PROCESS_INFORMATION NewProcess;	// Informaes sobre novo processo criado
	char Mensagem[MSG_SIZE]="";
	char *lpImage;			// Apontador para imagem local
	HANDLE hSection;
	HANDLE hEventSent;
	HANDLE hEventRead;
		
	hSection= CreateFileMapping(
		(HANDLE)0xFFFFFFFF,
		NULL,
		PAGE_READWRITE,		// tipo de acesso
		0,					// dwMaximumSizeHigh
		MSG_SIZE,					// dwMaximumSizeLow
		"MADONNA");			// Escolha o seu nome preferido
	CheckForError(hSection);

	lpImage= (char *)MapViewOfFile(
		hSection,
		FILE_MAP_WRITE,		// Direitos de acesso: leitura e escrita
		0,					// dwOffsetHigh
		0,					// dwOffset Low
		MSG_SIZE);			// Nmero de bytes a serem mapeados
	CheckForError(lpImage);

	// Cria evento com reset automtico
	hEventSent= CreateEvent(NULL, FALSE, FALSE,"MsgAvailable");
	CheckForError(hEventSent);

	// Cria evento com reset automtico
	hEventRead= CreateEvent(NULL, FALSE, FALSE,"MsgRead");
	CheckForError(hEventRead);
		
	// Cria processo servidor
	ZeroMemory(&si, sizeof(si));
	si.cb = sizeof(si);	// Tamanho da estrutura em bytes

	bStatus = CreateProcess(
		"c:\\Livro\\Programas\\Prog65Server\\Debug\\Prog65Server.exe", // Nome
		NULL,	// linha de comando
		NULL,	// atributos de segurana: Processo
		NULL,	// atributos de segurana: Thread
		FALSE,	// herana de handles
		NORMAL_PRIORITY_CLASS,	// CreationFlags
		NULL,	// lpEnvironment
		NULL,	// diretrio corrente do filho
		&si,			// lpStartUpInfo
		&NewProcess);	// lpProcessInformation
	CheckForError(bStatus);


	do {
		printf("Entre com nova Mensagem a ser enviada\n");
		bStatus = bGetString(Mensagem, MSG_SIZE);
		printf("\n");

		// Escreve na memria compartilhada
		if (bStatus) strcpy(lpImage, Mensagem);	
		else strcpy(lpImage, "");; // Aborta Processo Servidor
		SetEvent(hEventSent);	// Avisa processo B
		
		if (!bStatus) break;

		// Espera que processo B leia a mensagem 
		WaitForSingleObject(hEventRead, INFINITE); 
		ResetEvent(hEventRead);
		printf("Buffer apos leitura/limpeza [deve ser NULL]= %s\n\n", lpImage);
	} while(TRUE);

	// Elimina mapeamento
	bStatus=UnmapViewOfFile(lpImage);
	CheckForError(bStatus);

	CloseHandle(hSection);
	CloseHandle(hEventSent);
	CloseHandle(hEventRead);
	CloseHandle(NewProcess.hProcess);
	CloseHandle(NewProcess.hThread);

	printf("\nAperte uma tecla...\n");
	_getch();
	
	ExitProcess(0);
	return EXIT_SUCCESS;
}	// main


